// EinsteinWidget
// (C) 2005 Joerg Seyfried and Joerg Klose
//
// http://www.unitedmacs.com
// http://www.macmini-forum.de
//
// Modified for Einstein@Home by Michael Tughan
// (C) 2006 Michael's Programming
//
// http://home.interlog.com/~kidcare/michaelsprogramming

var results = ["", "Enter your ID", "", "", "", "", "", ""];
var id = -1, proj = -1, teamname = null, reloadint = -1, last_updated = 0, reloadvals = [30, 60, 120, 240];
var domain, xml_http = null;
var   RegExp = /Account Data.+?for ([^<]+).+?Time: (.+) UTC.+User TotCred: ([\d,\.]+).+?User AvgCred: ([\d,\.]+).+?Team: ([^<]+).+?Team TotCred: ([\d,\.]+).+?Team AvgCred: ([\d,\.]+).+?/;
var RegExpNT = /Account Data.+?for ([^<]+).+?Time: (.+) UTC.+User TotCred: ([\d,\.]+).+?User AvgCred: ([\d,\.]+).+?Team: ([^<]+).+?/;
var names = [
	'ABC@Home',
	'BBC Climate Change',
	'BURP',
	'Chess960@Home',
	'Climateprediction.net',
	'Climateprediction.net Beta',
	'DepSpid',
	'Docking@Home',
	'Einstein@Home',
	'Hash Clash',
	'Leiden Classical',
	'LHC@Home',
	'Malariacontrol.net',
	'Nano-Hive@Home',
	'Pirates@Home',
	'Predictor@Home',
	'PrimeGrid',
	'Project Neuron',
	'Proteins@Home',
	'Orbit@Home',
	'QMC@Home',
	'RALPH@Home',
	'Rectilinear Crossing Number',
	'RenderFarm@Home',
	'Riesel Sieve',
	'Rosetta@Home',
	'Seasonal Attribution Project',
	'SETI@Home',
	'SIMAP',
	'Spinhenge@Home',
	'SZTAKI DesktopGrid',
	'Tanpaku',
	'TMRL DRTG',
	'uFluids',
	'vtu@Home',
	'World Community Grid',
	'XtremLab'];
var enterID = ["", "Enter your ID", "", "", "", "", "", ""];

function gotouserpage() {
	if(names[proj] != 'World Community Grid') {
		widget.openURL(domain + '/show_user.php?userid=' + id);
	}
	else {
		widget.openURL('http://www.worldcommunitygrid.org/stat/viewMemberInfo.do?userName=' + id);
	}
}

function searchteam() {
	if (teamname != null) {
		if(names[proj] != 'World Community Grid') {
			widget.openURL(domain + '/team_lookup.php?search=Search&team_name=' + teamname);
		}
		else {
			widget.openURL('http://www.worldcommunitygrid.org/team/viewSearchResults.do?searchOption=name&searchValue=' + teamname);
		}
	}
}


function setup() {
    createGenericButton(document.getElementById('done'), 'done', hidePrefs);
    if(window.widget) {
    	reloadint = widget.preferenceForKey('reloadinterval');
    	id = widget.preferenceForKey('id');
    	proj = widget.preferenceForKey('proj');
    }
    if (reloadint == null || reloadint == -1) reloadint = 0;
	if (proj == null || proj == -1) proj = 0;
    if (id == null || id == -1) {
		document.getElementById('user').value = "Your ID";
		results = enterID;
		showValues();
		setTitle("BOINC Statistics");
    }
    else {
		document.getElementById('user').value = id;
		load();
    }
    document.getElementById('checkupdates').selectedIndex = reloadint;
	document.getElementById('proj').selectedIndex = proj;
}

function load() {
	var now = (new Date).getTime();
	if ((now - last_updated) > reloadvals[reloadint] * 60000) {
	    if (id == null) {
	    	setTitle("BOINC Statistics");
	    	results = enterID;
	    	showValues();
	    }
	    else {
	    	last_updated = (new Date).getTime();
			xml_http = new XMLHttpRequest();
			domain = 'http://' + document.getElementById('proj').options[proj].value;
			xml_http.open("GET", domain + '/userw.php?id=' + id);
			xml_http.onreadystatechange = show;
			xml_http.send(null);
		}
	}
}

function show() {
	if(xml_http == null || xml_http.readyState != 4) return;
	if(xml_http.status != 200) {
		results = ["", "Could not get stats!", "", "", "", "", ""];
		showValues();
	}
	else {
		var response = xml_http.responseText;
		results = RegExpNT.exec(response);
		if (results[5] != "None") results = RegExp.exec(response);
		
		setTitle(names[proj] + " Stats");
		showValues();
	}
}

function showValues() {
	document.getElementById("name1").innerText = results[1];
	document.getElementById("time1").innerText = results[2];
	document.getElementById("totcred1").innerText = results[3];
	document.getElementById("avgcred1").innerText = results[4];
	document.getElementById("team1").innerText = results[5];
	if (results[5]!="None") {
		teamname = results[5];
		document.getElementById("teamt1").innerText = results[6];
		document.getElementById("teama1").innerText = results[7];
	}
	else {
		document.getElementById("teamt1").innerText = "";
		document.getElementById("teama1").innerText = "";
	}
}
function setTitle(title) {
	document.getElementById("title").innerText = title;
}


if (window.widget)
{
	widget.onshow = show;
}


function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
	widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	exitflip(event);

	if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
	    widget.prepareForTransition("ToFront");

    back.style.display="none";
    front.style.display="block";
	
	id = document.getElementById('user').value;
    reloadint = document.getElementById('checkupdates').selectedIndex;
    proj = document.getElementById('proj').selectedIndex;
	if(window.widget) {
		widget.setPreferenceForKey(reloadint, 'reloadinterval');
    	widget.setPreferenceForKey(proj, 'proj');
    	widget.setPreferenceForKey(id, 'id');
    }
	last_updated = 0;
    load();
		
	if (window.widget)
	    setTimeout ('widget.performTransition();', 0);

    // Let's not propagate this old bug:
    flipShown = false;
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
var animation2 = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer	 = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate(animation);", 13);
	animation.from = animation.now;
	animation.to = 1.0;
	animate(animation);
	flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
	// fade in the info button
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer	 = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate(animation);", 13);
	animation.from = animation.now;
	animation.to = 0.0;
	animate(animation);
	flipShown = false;
	}
}

function animate(animator) {
	var T;
	var ease;
	var time = (new Date).getTime();


	T = limit_3(time-animator.starttime, 0, animator.duration);

	if (T >= animator.duration)
	{
	clearInterval (animator.timer);
	animator.timer = null;
	animator.now = animator.to;
	}
	else
	{
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animator.duration));
	animator.now = computeNextFloat (animator.from, animator.to, ease);
	}

	animator.firstElement.style.opacity = animator.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	if (animation2.timer != null)
	{
		clearInterval (animation2.timer);
		animation2.timer = null;
	}
	var starttime = (new Date).getTime() - 13;

	animation2.duration = 150;
	animation2.starttime = starttime;
	animation2.firstElement = document.getElementById ('fliprollie');
	animation2.timer = setInterval ("animate(animation2);", 13);
	animation2.from = animation2.now;
	animation2.to = 0.25;
	animate(animation2);
}

function exitflip(event)
{
	if (animation2.timer != null)
	{
		clearInterval (animation2.timer);
		animation2.timer	 = null;
	}
	var starttime = (new Date).getTime() - 13;

	animation2.duration = 300;
	animation2.starttime = starttime;
	animation2.firstElement = document.getElementById ('fliprollie');
	animation2.timer = setInterval ("animate(animation2);", 13);
	animation2.from = animation2.now;
	animation2.to = 0.0;
	animate(animation2);
}